



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>JAVA之旅（三十三）——TCP传输，互相（伤害）传输，复制文件，上传图片，多并发上传，多并发登录</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">JAVA之旅（三十三）——TCP传输，互相（伤害）传输，复制文件，上传图片，多并发上传，多并发登录</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 23:39:05 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<h1>JAVA之旅（三十三）——TCP传输，互相（伤害）传输，复制文件，上传图片，多并发上传，多并发登录</h1>
<hr>
<blockquote><p>我们继续网络编程</p></blockquote>
<h2>一.TCP</h2>
<blockquote><p>说完UDP，我们就来说下我们应该重点掌握的TCP了</p></blockquote>
<ul><li>TCP传输</p>
<ul><li>Socket和ServiceSocket</li>
<li>建立客户端和服务端</li>
<li>建立连接后，通过Socket中的IO流进行数据的传输</li>
<li>关闭Socket</li></ul></li></ul>
<blockquote><p>同样的，我们的客户端和服务端都是两个独立的应用</p>
<p>我们通过查阅API文档发现，该对象在建立的时候，就可以去连接指定主机，因为tcp是面向连接的，所以在建立socket服务时，就要有服务存在，并成功连接，形成通路后，在该通道进行数据传输</p>
<p>所以我们用代码来看下他的步骤</p></blockquote>
<h3>客户端</h3>
<pre class="prettyprint linenums"><code>package com.lgl.hellojava;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.UnknownHostException;

public class TcpClient {

    public static void main(String[] args) {
        try {
            //1.创建客户端的服务，传地址和端口
            Socket s = new Socket("192.168.1.102",10000);
            //2.为了发送数据，应该获得socket流中的输出流
            OutputStream out = s.getOutputStream();
            out.write("你好".getBytes());
            s.close();
        } catch (UnknownHostException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
}

</code></pre>
<h3>服务端</h3>
<pre class="prettyprint linenums"><code>package com.lgl.hellojava;

import java.io.IOException;
import java.io.InputStream;
import java.net.ServerSocket;
import java.net.Socket;

/**
 * 定义端点接收数据打印出来
 * 服务端：
 * 1.建立服务端的socket服务，servicesocket,并监听一个端口
 * 2.获取连接过来的客户端对象，通过accept方法，这个方法是阻塞的，没有连接就会等
 * 3.客户端如果发过来数据，那么服务端要使用对应的客户端对象，并获取到该对象的读取流
 * 4.关闭服务端（可选操作）
 * @author LGL
 *
 */
public class TcpService {
    public static void main(String[] args) {
        try {
            //1.建立连接，监听端口
            ServerSocket ss = new ServerSocket(10000);
            //2.连接客户端对象
            Socket accept = ss.accept();
            //获取ip
            String ip = accept.getInetAddress().getHostAddress();
            //3.获取客户端发送过来的数据
            InputStream in = accept.getInputStream();
            //4.开始读取
            byte [] buf = new byte[1024];
            int len = in.read(buf);
            System.out.println(new String(buf,0,len));
            //5.关闭
            ss.close();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
}
</code></pre>
<h2>二.TCP互相传输</h2>
<blockquote><p>我们在来写一个实例去说明，他们的互访动作，这里为了写起来方便，就写在一个类中了</p></blockquote>
<pre class="prettyprint linenums"><code>package com.lgl.hellojava;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.UnknownHostException;

/**
 * 客户端发送信息，服务端收到，反馈信息
 *
 * @author LGL
 *
 */
public class Tcp {

    public static void main(String[] args) {
        try {
            Socket s = new Socket("192.168.1.102", 10005);
            OutputStream out = s.getOutputStream();
            out.write("我是客户端".getBytes());
            InputStream in = s.getInputStream();
            byte[] buf = new byte[1024];
            int len = in.read(buf);
            System.out.println(new String(buf, 0, len));
            s.close();
        } catch (UnknownHostException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
}
/**
 * 服务端
 * @author LGL
 *
 */
class Server {
    public static void main(String[] args) {
        try {
            ServerSocket ss = new ServerSocket(10005);
            Socket s = ss.accept();
            InputStream in = s.getInputStream();
            byte[] buf = new byte[1024];
            int len = in.read(buf);
            System.out.println(new String(buf, 0, len));

            OutputStream out = s.getOutputStream();
            out.write("收到后反馈".getBytes());
            s.close();
            ss.close();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
}
</code></pre>
<h2>三.复制文件</h2>
<blockquote><p>同样的这里也是使用的流，我们具体来看下怎么去操作，我们同样的，写在一个类中</p></blockquote>
<pre class="prettyprint linenums"><code>package com.lgl.socket;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.UnknownHostException;

public class FileClient {

    public static void main(String[] args) {
        try {
            Socket s = new Socket("192.168.1.102", 10006);
            BufferedReader bufr = new BufferedReader(new FileReader("test.txt"));
            PrintWriter pw = new PrintWriter(s.getOutputStream(), true);
            String line = null;
            while ((line = bufr.readLine()) != null) {
                pw.println(line);
            }
            pw.print("over");
            BufferedReader bufIn = new BufferedReader(new InputStreamReader(
                    s.getInputStream()));
            String str = bufIn.readLine();
            System.out.println(str);

            bufr.close();
            s.close();
        } catch (UnknownHostException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
}

class FileServer {
    public static void main(String[] args) {
        try {
            ServerSocket ss = new ServerSocket(10006);
            Socket s = ss.accept();

            BufferedReader bufIn = new BufferedReader(new InputStreamReader(
                    s.getInputStream()));
            PrintWriter out = new PrintWriter(new FileWriter("test1.txt"), true);
            String line = null;
            while ((line = bufIn.readLine()) != null) {
                if ("over".equals(line))
                    break;
                out.println(line);
            }
            PrintWriter pw = new PrintWriter(s.getOutputStream(), true);
            pw.println("上传成功");

            out.close();
            s.close();
            ss.close();

        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
}
</code></pre>
<h2>四.上传图片</h2>
<blockquote><p>我们再来看下图片是怎么上传的，我们先来分析下步骤</p></blockquote>
<h3>客户端</h3>
<ul><li>1.服务端点</li>
<li>2.读取客户端已有的图片数据</li>
<li>3.通过socket，发送给服务端</li>
<li>4.读取服务端反馈的信息</li>
<li>5.关闭资源</li></ul>
<pre class="prettyprint linenums"><code>**
 * 客户端
 *
 * @author LGL
 *
 */
public class PicClient {

    public static void main(String[] args) {
        try {
            Socket s = new Socket("192.168.1.102", 10009);
            FileInputStream fis = new FileInputStream("1.png");
            OutputStream out = s.getOutputStream();
            byte[] buf = new byte[1024];
            int len = 0;
            while ((len = fis.read(buf)) != -1) {
                out.write(buf, 0, len);
            }
            //告訴服务端数据写完
            s.shutdownInput();
            InputStream in = s.getInputStream();
            byte[] bufn = new byte[1024];
            int num = in.read(bufn);
            System.out.println(new String(bufn, 0, num));
            fis.close();
            s.close();
        } catch (UnknownHostException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
}
</code></pre>
<h3>服务端</h3>
<blockquote><p>直接看代码</p></blockquote>
<pre class="prettyprint linenums"><code>
/**
 * 服務端
 * @author LGL
 *
 */
class PicServer {
    public static void main(String[] args) {
        try {
            ServerSocket ss = new ServerSocket(10009);
            Socket s = ss.accept();
            InputStream in = s.getInputStream();
            FileOutputStream fos = new FileOutputStream("2.png");
            byte[] buf = new byte[1024];
            int len = 0;
            while ((len = in.read(buf)) != -1) {
                fos.write(buf, 0, len);
            }

            OutputStream out = s.getOutputStream();
            out.write("上传成功".getBytes());
            fos.close();
            s.close();
            ss.close();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
}</code></pre>
<blockquote><p>其实跟I/O区别真不大，但是概念一定要了解清楚</p></blockquote>
<h2>五.多并发上传</h2>
<blockquote><p>多并发这个概念就是多人互动了，这对服务器的负荷还是有考究的，这里呢，我们就模拟一下，多人上传图片的场景，我们是怎么做的？我们还是在上传图片的那份代码上更改</p>
<p>首先我们可以确定的是，这是服务端的代码</p></blockquote>
<ul><li>这个服务端有个局限性，当A客户端连接之后，被服务端获取到，服务端就在执行代码了，这个时候如果B客户端连接只有等待，这就是我们需要多并发的原因了，为了让多个客户端同时连接，服务端最好就是讲每个客户端封装到一个单独的线程中，这样就可以同时处理多个客户端请求</li></ul>
<blockquote><p>如何定义线程？</p></blockquote>
<ul><li>只要明确了每个客户端要在服务端执行的代码即可</li></ul>
<pre class="prettyprint linenums"><code>
/**
 * 服務端
 *
 * @author LGL
 *
 */
class PicServer {
    public static void main(String[] args) {
        try {
            ServerSocket ss = new ServerSocket(10009);
            while (true) {
                Socket s = ss.accept();
                new Thread(new PicThread(s)).start();
            }
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
}
/**
 * 并发线程
 * @author LGL
 *
 */
class PicThread implements Runnable {

    private Socket s;

    public PicThread(Socket s) {
        this.s = s;
    }

    @Override
    public void run() {
        try {
            String ip = s.getInetAddress().getHostAddress();
            System.out.println("ip：" + ip);

            long millis = System.currentTimeMillis();
            File file = new File(millis + ".png");
            InputStream in = s.getInputStream();
            FileOutputStream fos = new FileOutputStream(file);
            byte[] buf = new byte[1024];
            int len = 0;
            while ((len = in.read(buf)) != -1) {
                fos.write(buf, 0, len);
            }

            OutputStream out = s.getOutputStream();
            out.write("上传成功".getBytes());
            fos.close();
            s.close();
        } catch (Exception e) {

            throw new RuntimeException("上传失败");
        }

    }

}</code></pre>
<blockquote><p>其实我写的代码还是有点烂的，但是思想在就好，我们得先把思想学会了</p></blockquote>
<h2>六.多并发登录</h2>
<blockquote><p>上面说的多并发的上传，实在服务端端，现在我们来说下登录，是作用在客户端</p></blockquote>
<pre class="prettyprint linenums"><code>package com.lgl.socket;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.UnknownHostException;

public class LoginClient {

    public static void main(String[] args) {
        try {
            Socket s = new Socket("192.168.1.102", 10008);
            BufferedReader bufr = new BufferedReader(new InputStreamReader(
                    System.in));
            PrintWriter out = new PrintWriter(s.getOutputStream(), true);
            BufferedReader bufIn = new BufferedReader(new InputStreamReader(
                    s.getInputStream()));
            for (int i = 0; i &lt; 3; i++) {
                String line = bufr.readLine();
                if (line == null) {
                    break;
                }
                out.println(line);

                String info = bufIn.readLine();
                System.out.println("info:" + info);
                if (info.contains("欢迎")) {
                    break;
                }
            }
            bufr.close();
            s.close();
        } catch (UnknownHostException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
}

/**
 * 服务端
 *
 * @author LGL
 *
 */
class LoginServer {
    public static void main(String[] args) {
        try {
            ServerSocket ss = new ServerSocket(10008);
            while (true) {
                Socket s = ss.accept();
                new Thread(new UserThread(s)).start();
            }
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
}

/**
 * 并发登陆
 *
 * @author LGL
 *
 */
class UserThread implements Runnable {

    private Socket s;

    public UserThread(Socket s) {
        this.s = s;
    }

    @Override
    public void run() {
        for (int i = 0; i &lt; 3; i++) {
            try {
                BufferedReader bufrIn = new BufferedReader(
                        new InputStreamReader(s.getInputStream()));
                String name = bufrIn.readLine();

                // 模拟读取数据库的用户名
                BufferedReader bufr = new BufferedReader(new FileReader(
                        "user.txt"));

                PrintWriter out = new PrintWriter(s.getOutputStream(), true);

                String line = null;

                boolean flag = false;
                while ((line = bufr.readLine()) != null) {
                    if (line.equals(name)) {
                        flag = true;
                        break;
                    }
                }
                if (flag) {
                    System.out.println("已登录");
                    out.print("欢迎");
                } else {
                    System.out.println("重新登录");
                    out.println("用户名不存在");
                }
                s.close();

            } catch (IOException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }

        }
    }

}</code></pre>
<blockquote><p>OK,这些代码中可能会存在一些错误，因为代码并没有去实际的验证中，我写的时候也是跟着思想去走的，这样写代码是极为友好的，这就是TCP的冰山一角了，不过关于这些，还有很多知识点，我们要做的就是把思想给掌握了，万变不理其中</p>
<p>好的，最近写文的时间，有点懈怠了，看来要发力了，嘻嘻，</p></blockquote>
<h2>有兴趣的加群：555974449 一起来玩玩吧！</h2>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9p73n49.html">eclipse js 引用跳转</a>
		</li>
						<li><a href="https://www.batexi.com/a/4957j4vq.html">C&num; Socket系列二 简单的创建 socket 通信</a>
		</li>
						<li><a href="https://www.batexi.com/a/390142n8.html">netfilter-在内核态操作网络数据包</a>
		</li>
						<li><a href="https://www.batexi.com/a/390lepo9.html">数据库开发基础 SQL Server 数据库的备份、还原与分离、附加</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw13p38.html">FOJProblem 2214 Knapsack problem（01背包&plus;变性思维）</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zmyzd9.html">java笔记--反射机制之基础总结与详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/49553xm9.html">NBUT 1635 Explosion（最小顶点覆盖）</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jyx2g9.html">hadoop-2&period;7&period;3 在windows环境下安装（无需Cygwin）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1p6e59.html">WebRTC录音&lpar;1&rpar;-实现通话双向录音</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o520y9.html">HTML5 Web SQL Database 数据库的使用方法【图文说明】</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zwggz9.html">UIPickerView用法&lpar;左右比例，整体大小，字体大小&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdeyj5x9.html">获取上海地区AQI质量数据Python脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvl621q.html">subTree</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlll406q.html">tomcat编译项目后，classes文件没有相应的改变；</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2l122q.html">根据传入的文件名称动态从moglifs图片服务器拿到pdf文档并在线浏览</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjyyz69.html">c&plus;&plus; opencv 3&period;2 &plus;Mfc VS2015窗体显示图片方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5omm4q.html">day24（JAVAWEB上传与下载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emepvm9.html">【跨域】jsonp跨域实现方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/963307n9.html">设计模式之模板方法模式&amp;amp&semi;&amp;amp&semi;迪米特法则（代码Objective-C展示）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2504e8.html">简明PR教程</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8me6o32q.html">&lbrack;NOIp 2016&rsqb;天天爱跑步</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kxz609.html">2015 多校联赛 &mdash;&mdash;HDU5400（水）</a>
			</li>
						<li><a href="https://www.batexi.com/a/95010zz8.html">uva 10118（DP）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z1z609.html">bzoj 3631&colon; &lbrack;JLOI2014&rsqb;松鼠的新家</a>
			</li>
						<li><a href="https://www.batexi.com/a/9geyjm78.html">NOI2017游记</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj0llx9.html">初遇 Asp&period;net MVC 数据库依赖缓存那些事儿</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpzom69.html">二叉树的基本操作（含Huffman树）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j1m2v8.html">Access restriction&colon; The type VerticalTextSpinner is not accessible due to restriction on required library&period;&period;&period;&period;&period;&period;&period;&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1346mq.html">SSH构造struts2项目</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjeyyg8.html">cannot open file &amp;quot&semi;cxcore&period;lib&amp;quot&semi;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
